/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.9 by adcroft, Fri Sep 26 18:16:38 2003 UTC revision 1.53 by edhill, Fri Dec 5 15:08:33 2003 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 8  Line 8 
8  #   modified by aja 01/00  #   modified by aja 01/00
9  #   rewritten in bash by eh3 08/03  #   rewritten in bash by eh3 08/03
10    
11    # Search for particular CPP #cmds associated with packages
12    # usage: test_for_package_in_cpp_options CPP_file package_name
13    test_for_package_in_cpp_options() {
14        cpp_options=$1
15        pkg=$2
16        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20    }
21    
22    # Search for particular CPP #cmds associated with MPI
23    # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24    test_for_mpi_in_cpp_eeoptions() {
25        cpp_options=$1
26        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38        RETVAL=$?
39        if test "x${RETVAL}" = x0 ; then
40            echo -n "Error: In $file there is an illegal line: "
41            grep -i "$strng" $file
42            return 1
43        fi
44        return 0
45    }
46    
47    # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
48    # the package list.
49    expand_pkg_groups() {
50        new_packages=
51        PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
52        if test -r $PKG_GROUPS ; then
53            cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
54            cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
55            matched=0
56            for i in $PACKAGES ; do
57                line=`grep "^ *$i" ./p2.tmp`
58                RETVAL=$?
59                if test "x$RETVAL" = x0 ; then
60                    matched=1
61                    replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
62                    echo "    replacing \"$i\" with: $replace"
63                    new_packages="$new_packages $replace"
64                else
65                    new_packages="$new_packages $i"
66                fi
67            done
68            PACKAGES=$new_packages
69            rm -f ./p[1,2].tmp
70        else
71            echo "Warning: can't read package groups definition file: $PKG_GROUPS"
72        fi
73    }
74    
75  # Guess possible config options for this host  # Guess possible config options for this host
76  find_possible_configs()  {  find_possible_configs()  {
77    
78      p_PLATFORM=`uname`"-"`uname -m`      tmp1=`uname`"_"`uname -m`
79      echo "The platform appears to be:"      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
80      echo "  "$p_PLATFORM      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
81        PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
82      p_LN=      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
83        echo "  The platform appears to be:  $PLATFORM"
84        
85      echo "test" > test      echo "test" > test
86      ln -s ./test link      ln -s ./test link
87      RETVAL=$?      RETVAL=$?
88      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
89          p_LN="ln -s"          LN="ln -s"
90        else
91            echo "Error: \"ln -s\" does not appear to work on this system!"
92            echo "  For help, please contact <MITgcm-support@mitgcm.org>."
93            exit 1
94      fi      fi
95      rm -f test link      rm -f test link
96    
97      p_CPP=`which cpp`      if test "x$CPP" = x ; then
98                CPP="cpp -traditional -P"
99      RETVAL=$?      fi
100      if test "x${RETVAL}" = x0 ; then  
101          p_LN="ln -s"      # makedepend is not always available
102        if test "x${MAKEDEPEND}" = x ; then
103          which makedepend >& /dev/null
104          RETVAL=$?
105          if test "x${RETVAL}" = x1 ; then
106             echo "    makedepend was not found. Using xmakedpend instead."
107             MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
108          fi
109      fi      fi
     rm -f test link  
110    
111      # look for possible fortran compilers      # look for possible fortran compilers
112        tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
113      p_FC=      p_FC=
114      for c in f77 g77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 ; do      for c in $tmp ; do
115          which $c > /dev/null 2>&1          rm -f ./hello.f ./hello
116            cat >> hello.f <<EOF
117          program hello
118          do i=1,3
119            print *, 'hello world : ', i
120          enddo
121          end
122    EOF
123            $c -o hello hello.f > /dev/null 2>&1
124          RETVAL=$?          RETVAL=$?
125          if test "x${RETVAL}" = x0 ; then          if test "x${RETVAL}" = x0 ; then
126              p_FC="$p_FC $c"              p_FC="$p_FC $c"
127          fi          fi
128      done      done
129      echo "Possible FORTRAN compilers appear to be:  "      rm -f ./hello.f ./hello
130      if test "x${p_FC}" = x ; then      if test "x${p_FC}" = x ; then
131          echo "  None found!!!"          cat 1>&2 <<EOF
132    
133    Error: No Fortran compilers were found in your path.  Please specify one using:
134    
135        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
136        2) a command-line option (eg. "-fc NAME"), or
137        3) the MITGCM_FC environment variable.
138    
139    EOF
140            exit 1
141      else      else
142          echo "  "$p_FC          echo "  The possible FORTRAN compilers found in your path are:"
143            echo "   "$p_FC
144            if test "x$FC" = x ; then
145                FC=`echo $p_FC | $AWK '{print $1}'`
146            fi
147      fi      fi
148    
149      # look for possible MPI libraries      for i in $p_FC ; do
150      mpi_libs=          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
151      mpi_fort=`which mpif77 2>/dev/null`          if test -r $p_OF ; then
152      RETVAL=$?              OPTFILE=$p_OF
153      if test "x${RETVAL}" = x0 ; then              echo "  The options file:  $p_OF"
154          cat >>test.f <<EOF              echo "    appears to match so we'll use it."
155        PROGRAM HELLO              break
       DO 10, I=1,10  
       PRINT *,'Hello World'  
    10 CONTINUE  
       STOP  
       END  
 EOF  
         eval "$mpi_fort -showme test.f > out"  
         RETVAL=$?  
         if test "x${RETVAL}" = x0 ; then  
             a=`cat out`  
             for i in $a ; do  
                 case $i in  
                     -*)  
                         mpi_libs="$mpi_libs $i" ;;  
                 esac  
             done  
             echo "The MPI libs appear to be:"  
             echo "  "$mpi_libs  
156          fi          fi
157          rm -f test.f out      done
158        if test "x$OPTFILE" = x ; then
159            cat 1>&2 <<EOF
160    
161    Error: No options file was found in:  $ROOTDIR/tools/build_options/
162      that matches this platform ("$PLATFORM") and the compilers found in
163      your path.  Please specify an "optfile" using:
164    
165        1) the command line (eg. "-optfile=path/to/OPTFILE"), or
166        2) the MITGCM_OF environment variable.
167    
168      If you need help, please contact the developers at <MITgcm-support@mitgcm.org>.
169    
170    EOF
171            exit 1
172      fi      fi
173        
174    #     # look for possible MPI libraries
175    #     mpi_libs=
176    #     mpi_fort=`which mpif77 2>/dev/null`
177    #     RETVAL=$?
178    #     if test "x${RETVAL}" = x0 ; then
179    #       cat >>test.f <<EOF
180    #       PROGRAM HELLO
181    #       DO 10, I=1,10
182    #       PRINT *,'Hello World'
183    #    10 CONTINUE
184    #       STOP
185    #       END
186    # EOF
187    #       eval "$mpi_fort -showme test.f > out"
188    #       RETVAL=$?
189    #       if test "x${RETVAL}" = x0 ; then
190    #           a=`cat out`
191    #           for i in $a ; do
192    #               case $i in
193    #                   -*)
194    #                       mpi_libs="$mpi_libs $i" ;;
195    #               esac
196    #           done
197    #           echo "The MPI libs appear to be:"
198    #           echo "  "$mpi_libs
199    #       fi
200    #       rm -f test.f out
201    #     fi
202    
203  }  }
204    
# Line 86  get_pdepend_list()  { Line 208  get_pdepend_list()  {
208      #  strip the comments and then convert the dependency file into      #  strip the comments and then convert the dependency file into
209      #  two arrays: PNAME, DNAME      #  two arrays: PNAME, DNAME
210      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
211          | awk 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
212          > ./.pd_tmp          > ./.pd_tmp
213      source ./.pd_tmp      . ./.pd_tmp
214      rm -f ./.pd_tmp      rm -f ./.pd_tmp
215    
216      echo -n "PNAME = "${}      echo -n "PNAME = "${}
# Line 97  get_pdepend_list()  { Line 219  get_pdepend_list()  {
219    
220  #  Explain usage  #  Explain usage
221  usage()  {  usage()  {
222      echo  cat <<EOF
223      echo "Usage: "$0" [OPTIONS]"  
224      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
225      echo    where [OPTIONS] can be:
226      echo "    -help | --help | -h | --h"  
227      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
228      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
229      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
230      echo "    -pdepend NAME | --pdepend NAME"      -nooptfile | --nooptfile
231      echo "      -pdepend=NAME | --pdepend=NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
232      echo "    -pdefault NAME | --pdefault NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
233      echo "      -pdefault=NAME | --pdefault=NAME"            Use "NAME" as the optfile.  By default, an attempt will be
234      echo "    -make NAME | -m NAME"            made to find an appropriate "standard" optfile in the
235      echo "      --make=NAME | -m=NAME"            tools/build_options/ directory.
236      echo "    -makefile NAME | -mf NAME"  
237      echo "      --makefile=NAME | -mf=NAME"      -pdepend NAME | --pdepend NAME
238      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"        -pdepend=NAME | --pdepend=NAME
239      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            Get package dependency information from "NAME".
240      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"  
241      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"      -pdefault NAME | --pdefault NAME
242      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"        -pdefault=NAME | --pdefault=NAME
243      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"            Get the default package list from "NAME".
244      echo "    -disable NAME | --disable NAME"  
245      echo "      -disable=NAME | --disable=NAME"      -make NAME | -m NAME
246      echo "    -enable NAME | --enable NAME"        --make=NAME | -m=NAME
247      echo "      -enable=NAME | --enable=NAME"            Use "NAME" for the MAKE program. The default is "make" but
248      echo "    -noopt NAME | --noopt NAME"            many platforms, "gmake" is the preferred choice.
249      echo "      -noopt=NAME | --noopt=NAME"  
250  #    echo "    -cpp NAME | --cpp NAME"      -makefile NAME | -mf NAME
251  #    echo "      -cpp=NAME | --cpp=NAME"        --makefile=NAME | -mf=NAME
252      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"            Call the makefile "NAME".  The default is "Makefile".
253      echo "      -fc=NAME | --fc=NAME"  
254      echo "    -[no]ieee | --[no]ieee"      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
255      echo "    -[no]mpi | --[no]mpi"        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
256      echo "    -[no]jam | --[no]jam"            Specify the location of the MITgcm ROOTDIR as "NAME".
257      echo            By default, genamke will try to find the location by
258      echo "  and NAME is a string such as:"            looking in parent directories (up to the 5th parent).
259      echo  
260      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"      -mods NAME | --mods NAME | -mo NAME | --mo NAME
261      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"        -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
262      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"            Here, "NAME" specifies a list of directories that are
263      echo            used for additional source code.  Files found in the
264      echo "  which, depending upon your shell, may need to be single-quoted"            "mods list" are given preference over files of the same
265      echo "  if it contains spaces, dashes, or other special characters."            name found elsewhere.
266    
267        -disable NAME | --disable NAME
268          -disable=NAME | --disable=NAME
269              Here "NAME" specifies a list of packages that we don't
270              want to use.  If this violates package dependencies,
271              genamke will exit with an error message.
272    
273        -enable NAME | --enable NAME
274          -enable=NAME | --enable=NAME
275              Here "NAME" specifies a list of packages that we wish
276              to specifically enable.  If this violates package
277              dependencies, genamke will exit with an error message.
278    
279        -standarddirs NAME | --standarddirs NAME
280          -standarddirs=NAME | --standarddirs=NAME
281              Here, "NAME" specifies a list of directories to be
282              used as the "standard" code.
283    
284        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
285          -fc=NAME | --fc=NAME
286              Use "NAME" as the fortran compiler.  By default, genmake
287              will search for a working compiler by trying a list of
288              "usual suspects" such as g77, f77, etc.
289    
290        -[no]ieee | --[no]ieee
291              Do or don't use IEEE numerics.  Note that this option
292              *only* works if it is supported by the OPTFILE that
293              is being used.
294    
295      While it is most often a single word, the "NAME" variables specified
296      above can in many cases be a space-delimited string such as:
297    
298        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
299        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
300        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
301    
302      which, depending upon your shell, may need to be single-quoted.
303    
304      For more detailed genmake documentation, please see:
305    
306        http://mitgcm.org/devel_HOWTO/
307    
308    EOF
309    
310      exit 1      exit 1
311  }  }
312    
313  #eh3 # This is the generic configuration.  #  Build a CPP macro to automate calling C routines from FORTRAN
314  #eh3 set LN         = ( 'ln -s' )  get_fortran_c_namemangling()  {
315  #eh3 set CPP        = ( '/lib/cpp -P' )      default_nm="#define FC_NAMEMANGLE(X) X ## _"
316  #eh3 set S64        = ( '$(TOOLSDIR)/set64bitConst.sh' )      
317  #eh3 set KPP        = (  )      cat > genmake_test.c <<EOF
318  #eh3 set FC         = ( 'f77' )  void tcall( char * string ) { tsub( string ); }
319  #eh3 set LINK       = $FC  EOF
320  #eh3 set MAKEDEPEND = ( 'makedepend' )      $MAKE genmake_test.o >> genmake_warnings 2>&1
321  #eh3 set INCLUDES   = ( -I. )      RETVAL=$?
322  #eh3 set FFLAGS     = (  )      if test "x$RETVAL" != x0 ; then
323  #eh3 set FOPTIM     = (  )          FC_NAMEMANGLE=$default_nm
324  #eh3 set CFLAGS     = (  )          cat <<EOF>> genmake_errors
325  #eh3 set KFLAGS1    = (  )  
326  #eh3 set KFLAGS2    = (  )  WARNING: C test compile fails
327  #eh3 set LIBS       = (  )  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
328  #eh3 set KPPFILES   = (  )  WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
329  #eh3 if (! $?NOOPTFILES ) set NOOPTFILES = (  )  EOF
330  #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = (  )          return 1
331        fi
332        c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
333        RETVAL=$?
334        if test "x$RETVAL" != x0 ; then
335            FC_NAMEMANGLE=$default_nm
336            cat <<EOF>> genmake_warnings
337    
338    WARNING: The "nm" command failed.
339    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
340    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
341    EOF
342            return 1
343        fi
344        cat > genmake_tcomp.f <<EOF
345          subroutine tcall( string )
346          character*(*) string
347          call tsub( string )
348          end
349    EOF
350        $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1
351        RETVAL=$?
352        if test "x$RETVAL" != x0 ; then
353            FC_NAMEMANGLE=$default_nm
354            cat <<EOF>> genmake_warnings
355    
356    WARNING: FORTRAN test compile fails -- please see "genmake_errors"
357    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
358    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
359    EOF
360            return 1
361        fi
362        f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
363        RETVAL=$?
364        if test "x$RETVAL" != x0 ; then
365            FC_NAMEMANGLE=$default_nm
366            cat <<EOF>> genmake_warnings
367    
368    WARNING: The "nm" command failed.
369    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
370    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
371    EOF
372            return 1
373        fi
374    
375        c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
376        f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
377        c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
378        f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
379    
380        nmangle="X"
381        if test "x$c_a" != "x$f_a" ; then
382            comm="echo x$f_a | sed -e 's|x$c_a||'"
383            a=`eval $comm`
384            nmangle="$a ## $nmangle"
385        fi
386        if test "x$c_b" != "x$f_b" ; then
387            comm="echo x$f_b | sed -e 's|x$c_b||'"
388            b=`eval $comm`
389            nmangle="$nmangle ## $b"
390        fi
391    
392        FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmangle"
393    
394        #  cleanup the testing files
395        rm -f genmake_tcomp.* genmake_test.*
396    }
397    
398    
399    check_HAVE_CLOC()  {
400        get_fortran_c_namemangling
401        cat <<EOF > genmake_tc_1.c
402    $FC_NAMEMANGLE
403    #include <stdio.h>
404    #include <stdlib.h>
405    #include <unistd.h>
406    #include <assert.h>
407    #include <sys/time.h>
408    void FC_NAMEMANGLE(cloc) ( double *curtim )
409    {
410     struct timeval tv1;
411     gettimeofday(&tv1 , (void *)NULL );
412     *curtim =  (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
413     *curtim = *curtim/1.E6;
414    }
415    EOF
416        make genmake_tc_1.o >> genmake_tc.log 2>&1
417        RET_C=$?
418        cat <<EOF > genmake_tc_2.f
419          program hello
420          Real*8 wtime
421          external cloc
422          call cloc(wtime)
423          print *," HELLO WORLD", wtime
424          end program hello
425    EOF
426        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
427        RET_F=$?
428        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
429        RETVAL=$?
430        if test "x$RETVAL" = x0 ; then
431            HAVE_CLOC=t
432            DEFINES="$DEFINES -DHAVE_CLOC"
433        fi
434        rm -f genmake_tc*
435    }
436    
437    
438  #  Set defaults here  #  Set defaults here
439  COMMANDL="$0 $@"  COMMANDL="$0 $@"
# Line 172  S64= Line 444  S64=
444  KPP=  KPP=
445  FC=  FC=
446  LINK=  LINK=
447    # DEFINES="-DWORDLENGTH=4"
448    DEFINES=
449  PACKAGES=  PACKAGES=
450  ENABLE=  ENABLE=
451  DISABLE=  DISABLE=
452  MAKEFILE=  MAKEFILE=
453  MAKEDEPEND=  MAKEDEPEND=
454  PDEPEND=  PDEPEND=
455  DUMPSTATE=f  DUMPSTATE=t
456  PDEFAULT=  PDEFAULT=
457  OPTFILE=  OPTFILE=
458  INCLUDES="-I."  INCLUDES="-I."
# Line 192  KPPFILES= Line 466  KPPFILES=
466  NOOPTFILES=  NOOPTFILES=
467  NOOPTFLAGS=  NOOPTFLAGS=
468    
469    # DEFINES checked by test compilation
470    HAVE_SYSTEM=
471    HAVE_FDATE=
472    FC_NAMEMANGLE=
473    HAVE_CLOC=
474    
475  MODS=  MODS=
476  TOOLSDIR=  TOOLSDIR=
477  SOURCEDIRS=  SOURCEDIRS=
478  INCLUDEDIRS=  INCLUDEDIRS=
479    STANDARDDIRS=
480    
481  PWD=`pwd`  PWD=`pwd`
482  MAKE=make  MAKE=make
483    AWK=awk
484  THISHOSTNAME=`hostname`  THISHOSTNAME=`hostname`
485  THISCWD=`pwd`  THISCWD=`pwd`
486  THISDATE=`date`  THISDATE=`date`
# Line 206  MACHINE=`uname -a` Line 488  MACHINE=`uname -a`
488  EXECUTABLE=  EXECUTABLE=
489  EXEHOOK=  EXEHOOK=
490  EXEDIR=  EXEDIR=
491    PACKAGES_CONF=
492    IEEE=
493    if test "x$MITGCM_IEEE" != x ; then
494        IEEE=$MITGCM_IEEE
495    fi
496    
497    AUTODIFF_PKG_USED=f
498    AD_OPTFILE=
499    TAF=
500    AD_TAF_FLAGS=
501    FTL_TAF_FLAGS=
502    SVD_TAF_FLAGS=
503    TAF_EXTRA=
504    TAMC=
505    AD_TAMC_FLAGS=
506    FTL_TAF_FLAGS=
507    SVD_TAMC_FLAGS=
508    TAMC_EXTRA=
509    
510    
511  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
512  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
513  gm_s2="FC IEEE MPI JAM DUMPSTATE"  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"
514    
515  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
516  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
517  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
518  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
519  gm_s6="EXECUTABLE EXEHOOK EXEDIR"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
520    gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"
521    
522  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6"  #  The following are all related to adjoint/tangent-linear stuff
523    gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
524    gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
525    gm_s12="TAF_EXTRA TAMC_EXTRA"
526    
527    gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
528    gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
529    
530    cat <<EOF
531    
532    GENMAKE :
533    
534    A program for GENerating MAKEfiles for the MITgcm project.  For a
535    quick list of options, use "genmake -h" or for more detail see:
536    
537      http://mitgcm.org/devel_HOWTO/
538    
539    EOF
540    
 echo  
541  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
542  gm_local="./gm_local"  gm_local="genmake_local"
543    for i in . $MODS ; do
544        if test -r $i/$gm_local ; then
545            . $i/$gm_local
546            break
547        fi
548    done
549  echo -n "  getting local config information:  "  echo -n "  getting local config information:  "
550  if test -e $gm_local ; then  if test -e $gm_local ; then
551      echo "using $gm_local"      echo "using $gm_local"
552      source $gm_local      . $gm_local
553      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
554      # echo "ENABLE=$ENABLE"      # echo "ENABLE=$ENABLE"
555  else  else
# Line 244  fi Line 567  fi
567  #   n=$(( $n + 1 ))  #   n=$(( $n + 1 ))
568  #done  #done
569  #parse_options  #parse_options
   
570  ac_prev=  ac_prev=
571  for ac_option ; do  for ac_option ; do
572    
# Line 269  for ac_option ; do Line 591  for ac_option ; do
591          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
592              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
593                    
594            -adoptfile | --adoptfile | -adof | --adof)
595                ac_prev=AD_OPTFILE ;;
596            -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
597                AD_OPTFILE=$ac_optarg ;;
598            
599          -pdepend | --pdepend)          -pdepend | --pdepend)
600              ac_prev=PDEPEND ;;              ac_prev=PDEPEND ;;
601          -pdepend=* | --pdepend=*)          -pdepend=* | --pdepend=*)
# Line 289  for ac_option ; do Line 616  for ac_option ; do
616          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
617              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
618                    
619          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
620              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
621          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
622              PLATFORM=$ac_optarg ;;              echo
623                usage
624                ;;
625                    
626          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
627              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 314  for ac_option ; do Line 643  for ac_option ; do
643          -enable=* | --enable=*)          -enable=* | --enable=*)
644              ENABLE=$ac_optarg ;;              ENABLE=$ac_optarg ;;
645                    
646          -noopt | --noopt)          -standarddirs | --standarddirs)
647              ac_prev=NOOPT ;;              ac_prev=STANDARDDIRS ;;
648          -noopt=* | --noopt=*)          -standarddirs=* | --standarddirs=*)
649              NOOPT=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
650            
651  #           -cpp | --cpp)  #           -cpp | --cpp)
652  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
653  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
# Line 330  for ac_option ; do Line 659  for ac_option ; do
659              FC=$ac_optarg ;;              FC=$ac_optarg ;;
660                    
661          -ieee | --ieee)          -ieee | --ieee)
662              IEEE=1 ;;              IEEE=true ;;
663          -noieee | --noieee)          -noieee | --noieee)
664              IEEE=0 ;;              IEEE= ;;
665                    
666          -mpi | --mpi)  #       -jam | --jam)
667              MPI=1 ;;  #           JAM=1 ;;
668          -nompi | --nompi)  #       -nojam | --nojam)
669              MPI=0 ;;  #           JAM=0 ;;
           
         -jam | --jam)  
             JAM=1 ;;  
         -nojam | --nojam)  
             JAM=0 ;;  
670                    
671          -ds | --ds)          -ds | --ds)
672              DUMPSTATE=t ;;              DUMPSTATE=t ;;
673                    
674            -taf_extra | --taf_extra)
675                ac_prev=TAF_EXTRA ;;
676            -taf_extra=* | --taf_extra=*)
677                TAF_EXTRA=$ac_optarg ;;
678    
679            -tamc_extra | --tamc_extra)
680                ac_prev=TAMC_EXTRA ;;
681            -tamc_extra=* | --tamc_extra=*)
682                TAMC_EXTRA=$ac_optarg ;;
683    
684          -*)          -*)
685              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
686              usage              usage
# Line 361  for ac_option ; do Line 695  for ac_option ; do
695            
696  done  done
697    
698    if test -f ./.genmakerc ; then
699        echo
700        echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
701        echo "  file.  This file format is no longer supported.  Please see:"
702        echo
703        echo "    http://mitgcm.org/devel_HOWTO/"
704        echo
705        echo "  for directions on how to setup and use the new \"genmake2\" input"
706        echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."
707        echo
708    fi
709    
710    if test "x${ROOTDIR}" = x ; then
711        if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
712            ROOTDIR=".."
713        else
714            for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
715                if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
716                    ROOTDIR=$d
717                    echo -n "Warning:  ROOTDIR was not specified but there appears to be"
718                    echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
719                    break
720                fi
721            done
722        fi
723    fi
724    if test "x${ROOTDIR}" = x ; then
725        echo "Error: Cannot determine ROOTDIR for MITgcm code."
726        echo "  Please specify a ROOTDIR using either an options "
727        echo "  file or a command-line option."
728        exit 1
729    fi
730    if test ! -d ${ROOTDIR} ; then
731        echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"
732        exit 1
733    fi
734    
735  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
736  if test "x${OPTFILE}" = x ; then  if test "x${OPTFILE}" = x ; then
737      echo "Warning: no OPTFILE specified so we'll look for possible settings"      if test "x$MITGCM_OF" = x ; then
738      printf "\n===  Searching for possible settings for OPTFILE  ===\n"          echo "Warning: no OPTFILE specified so we'll look for possible settings"
739      find_possible_configs          printf "\n===  Searching for possible settings for OPTFILE  ===\n"
740  else          find_possible_configs
     if test "x$OPTFILE" = xNONE ; then  
         echo "    OPTFILE=NONE so we'll try to use default settings"  
741      else      else
742          if test -f "$OPTFILE" -a -r "$OPTFILE" ; then          OPTFILE=$MITGCM_OF
743              echo "    using OPTFILE=\"$OPTFILE\""      fi
744              source "$OPTFILE"  fi
745              RETVAL=$?  if test "x$OPTFILE" != xNONE ; then
746              if test "x$RETVAL" != x0 ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
747                  echo -n "Error: failed to source OPTFILE \"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
748                  echo "--please check that variable syntax is bash-compatible"          . "$OPTFILE"
749                  exit 1          RETVAL=$?
750              fi          if test "x$RETVAL" != x0 ; then
751              if test "x$DUMPSTATE" != xf ; then              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""
752                  cp -f $OPTFILE "gm_optfile"              echo "--please check that variable syntax is bash-compatible"
             fi  
         else  
             echo "Error: can't read OPTFILE=\"$OPTFILE\""  
753              exit 1              exit 1
754          fi          fi
755            if test "x$DUMPSTATE" != xf ; then
756                cp -f $OPTFILE "genmake_optfile"
757            fi
758        else
759            echo "Error: can't read OPTFILE=\"$OPTFILE\""
760            exit 1
761      fi      fi
762  fi  fi
763    
764  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  echo "  getting AD_OPTFILE information:  "
765  #  and abort!  if test "x${AD_OPTFILE}" = x ; then
766        if test "x$MITGCM_AD_OF" = x ; then
767            AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
768        else
769            AD_OPTFILE=$MITGCM_AD_OF
770        fi
771    fi
772    if test "x${AD_OPTFILE}" != xNONE ; then
773        if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
774            echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
775            . "$AD_OPTFILE"
776            RETVAL=$?
777            if test "x$RETVAL" != x0 ; then
778                echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
779                echo "--please check that variable syntax is bash-compatible"
780                exit 1
781            fi
782            if test "x$DUMPSTATE" != xf ; then
783                cp -f $AD_OPTFILE "genmake_ad_optfile"
784            fi
785        else
786            echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
787            exit 1
788        fi
789    fi
790    
791    #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
792    #  either set defaults or complain and abort!
793  if test "x$FC" = x ; then  if test "x$FC" = x ; then
794      cat <<EOF 1>&2      cat <<EOF 1>&2
795    
796  Error: no Fortran compiler: please specify using one of the following:  Error: no Fortran compiler: please specify using one of the following:
797    1) within the options file ("FC=...") as specified by "-of=OPTFILE"    1) within the options file ("FC=...") as specified by "-of=OPTFILE"
798    2) the "-fc=XXX" command-line option    2) the "-fc=XXX" command-line option
799    3) the "./gm_local" file    3) the "./genmake_local" file
800  EOF  EOF
801      exit 1      exit 1
802  fi  fi
# Line 405  if test "x$LINK" = x ; then Line 804  if test "x$LINK" = x ; then
804      LINK=$FC      LINK=$FC
805  fi  fi
806  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
807        CPP="cpp"
808    fi
809    if test "x$MAKE" = x ; then
810        MAKE="make"
811    fi
812    echo "#define A a" | $CPP > test_cpp 2>&1
813    RETVAL=$?
814    if test "x$RETVAL" != x0 ; then
815      cat <<EOF 1>&2      cat <<EOF 1>&2
816    
817  Error: no C pre-processor: please specify using one of the following:  Error: C pre-processor "$CPP" failed the test case: please specify using:
818    
819    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
820    2) the "./gm_local" file    2) the "./genmake_local" file
821      3) with the CPP environment variable
822    
823  EOF  EOF
824      exit 1      exit 1
825    else
826        rm -f test_cpp
827  fi  fi
828  if test "x$S64" = x ; then  if test "x$MAKEDEPEND" = x ; then
829        MAKEDEPEND=makedepend
830    fi
831    if test "x$LN" = x ; then
832        LN="ln -s"
833    fi
834    echo "test" > genmake_test_ln
835    $LN genmake_test_ln genmake_tlink
836    RETVAL=$?
837    if test "x$RETVAL" != x0 ; then
838      cat <<EOF 1>&2      cat <<EOF 1>&2
839    
840  Error: no C pre-processor: please specify using one of the following:  Error: The command "ln -s" failed -- please specify a working soft-link
841    1) within the options file ("S64=...") as specified by "-of=OPTFILE"    command in the optfile.
842    2) the "./gm_local" file  
843  EOF  EOF
844      exit 1      exit 1
845  fi  fi
846    rm -f genmake_test_ln genmake_tlink
847    
848    
849    printf "\n===  Checking system libraries  ===\n"
850    echo -n "  Do we have the system() command using $FC...  "
851    cat > genmake_tcomp.f <<EOF
852          program hello
853          call system('echo hi')
854          end
855    EOF
856    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
857    RETVAL=$?
858    if test "x$RETVAL" = x0 ; then
859        HAVE_SYSTEM=t
860        DEFINES="$DEFINES -DHAVE_SYSTEM"
861        echo "yes"
862    else
863        HAVE_SYSTEM=
864        echo "no"
865    fi
866    rm -f genmake_tcomp*
867    
868    echo -n "  Do we have the fdate() command using $FC...  "
869    cat > genmake_tcomp.f <<EOF
870          program hello
871          CHARACTER(128) string
872          string = ' '
873          call fdate( string )
874          print *, string
875          end
876    EOF
877    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
878    RETVAL=$?
879    if test "x$RETVAL" = x0 ; then
880        HAVE_FDATE=t
881        DEFINES="$DEFINES -DHAVE_FDATE"
882        echo "yes"
883    else
884        HAVE_FDATE=
885        echo "no"
886    fi
887    rm -f genmake_tcomp*
888    
889    echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
890    check_HAVE_CLOC
891    if test "x$HAVE_CLOC" != x ; then
892        echo "yes"
893    else
894        echo "no"
895    fi
896    rm -f genmake_t*
897    
898    
899  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
# Line 446  if test "x${PLATFORM}" = x ; then Line 918  if test "x${PLATFORM}" = x ; then
918      PLATFORM=$p_PLATFORM      PLATFORM=$p_PLATFORM
919  fi  fi
920    
 if test "x${ROOTDIR}" = x ; then  
     if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then  
         ROOTDIR=".."  
     else  
         for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do  
             if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then  
                 ROOTDIR=$d  
                 echo -n "Warning:  ROOTDIR was not specified but there appears to be"  
                 echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."  
                 break  
             fi  
         done  
     fi  
 fi  
 if test "x${ROOTDIR}" = x ; then  
     echo "Error: Cannot determine ROOTDIR for MITgcm code."  
     echo "  Please specify a ROOTDIR using either an options "  
     echo "  file or a command-line option."  
     exit 1  
 fi  
 if test ! -d ${ROOTDIR} ; then  
     echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"  
     exit 1  
 fi  
   
921  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
922      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then
923          EXEDIR=../exe          EXEDIR=../exe
# Line 490  if test ! -d ${TOOLSDIR} ; then Line 937  if test ! -d ${TOOLSDIR} ; then
937      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"
938      exit 1      exit 1
939  fi  fi
940    if test "x$S64" = x ; then
941        S64='$(TOOLSDIR)/set64bitConst.sh'
942    fi
943    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
944    
945  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
946    
# Line 498  EXECUTABLE=${EXECUTABLE:-mitgcmuv} Line 949  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
949  #  they appear as regular source code  #  they appear as regular source code
950  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
951      echo "  Making source files in eesupp from templates"      echo "  Making source files in eesupp from templates"
952      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1      ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
953      RETVAL=$?      RETVAL=$?
954      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
955          rm -f make_eesupp.errors          rm -f make_eesupp.errors
# Line 528  echo "  getting package dependency info Line 979  echo "  getting package dependency info
979  #  Strip the comments and then convert the dependency file into  #  Strip the comments and then convert the dependency file into
980  #  two arrays: PNAME, DNAME  #  two arrays: PNAME, DNAME
981  cat $PDEPEND | sed -e 's/#.*$//g' \  cat $PDEPEND | sed -e 's/#.*$//g' \
982      | awk 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \      | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
983      > ./.pd_tmp      > ./.pd_tmp
984  RETVAL=$?  RETVAL=$?
985  if test ! "x${RETVAL}" = x0 ; then  if test ! "x${RETVAL}" = x0 ; then
986      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
987      exit 1      exit 1
988  fi  fi
989  source ./.pd_tmp  . ./.pd_tmp
990  rm -f ./.pd_tmp  rm -f ./.pd_tmp
991    
992  echo  -n "  checking default package list:  "  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
993    #  file should eventually be added so that, for convenience, one can
994    #  specify groups of packages using names like "ocean" and "atmosphere".
995    echo "  checking default package list:  "
996    if test "x${PDEFAULT}" = x ; then
997        for i in "." $MODS ; do
998            if test -r $i"/packages.conf" ; then
999                    PDEFAULT=$i"/packages.conf"
1000                    break
1001            fi
1002        done
1003    fi
1004  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1005      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1006  fi  fi
1007  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1008      echo "default packages file disabled"      echo "    default packages file disabled"
1009  else  else
1010      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1011          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1012      else      else
1013          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1014          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1015          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | awk '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1016          RETVAL=$?          RETVAL=$?
1017          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1018              echo -n "Error: can't parse default package list "              echo -n "Error: can't parse default package list "
# Line 561  else Line 1022  else
1022          for i in $def ; do          for i in $def ; do
1023              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1024          done          done
1025          echo "    packages are:  $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1026            expand_pkg_groups
1027            echo "    after group expansion packages are:  $PACKAGES"
1028      fi      fi
1029  fi  fi
1030    
# Line 580  for p in $PACKAGES ; do Line 1043  for p in $PACKAGES ; do
1043  done  done
1044  PACKAGES="$pack"  PACKAGES="$pack"
1045  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1046  rm -f ./.tmp_pack  echo "" > ./.tmp_pack
1047  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1048  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1049      if test ! -d "$ROOTDIR/pkg/$i" ; then      if test ! -d "$ROOTDIR/pkg/$i" ; then
# Line 671  for i in $PACKAGES ; do Line 1134  for i in $PACKAGES ; do
1134      if test -d $adr ; then      if test -d $adr ; then
1135          SOURCEDIRS="$SOURCEDIRS $adr"          SOURCEDIRS="$SOURCEDIRS $adr"
1136          INCLUDEDIRS="$INCLUDEDIRS $adr"          INCLUDEDIRS="$INCLUDEDIRS $adr"
1137            if test "x$i" = xautodiff ; then
1138                AUTODIFF_PKG_USED=t
1139            fi
1140      else      else
1141          echo "Error: the directory \"$adr\" for package $i doesn't exist"          echo "Error: the directory \"$adr\" for package $i doesn't exist"
1142          exit 1          exit 1
1143      fi      fi
1144  done  done
1145    
 #  This is compatible with the old genmake.  The "DISABLE_*" flags  
 #  need to be replaced by the "ALLOW_*" flags set below.  
 #  
 # echo -n "  Setting package-specific CPP flags:  "  
 # pkrm=( mom_fluxform mom_vecinv generic_advdiff )  
 # pkrmdef=( -DDISABLE_MOM_FLUXFORM -DDISABLE_MOM_VECINV -DDISABLE_GENERIC_ADVDIFF -DDISABLE_DEBUGMODE )  
 # echo -n "  "  
 # i=0  
 # while test $i -lt "${#pkrm[@]}" ; do  
 #     echo "$PACKAGES" | grep "${pk[$i]}" > /dev/null 2>&1  
 #     RETVAL=$?  
 #     if test "x$RETVAL" = x1 ; then  
 #       DEFINES="$DEFINES ${pkdef[$i]}"  
 #       echo -n " ${pkdef[$i]}"  
 #     fi  
 #     i=$(( $i + 1 ))  
 # done  
 # echo  
   
 echo "  Setting package-specific CPP flags in CPP_OPTIONS.h:"  
 CPP_OPTIONS=  
 spaths="$SOURCEDIRS"  
 for i in $spaths ; do  
     try="$i/CPP_OPTIONS.h"  
     #  echo -n "    trying $try : "  
     if test -f $try -a -r $try ; then  
         echo "    found CPP_OPTIONS=\"$try\""  
         CPP_OPTIONS="$try"  
         if test "x$i" != "x." ; then  
             cp -f $CPP_OPTIONS .  
         fi  
         break  
     fi  
 done  
 if test "x$CPP_OPTIONS" = x ; then  
     echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"  
     exit 1  
 fi  
 if test -e CPP_OPTIONS.h ; then  
     if test ! -e CPP_OPTIONS.h.bak ; then  
         cp -f CPP_OPTIONS.h CPP_OPTIONS.h.bak  
     fi  
     cat CPP_OPTIONS.h \  
         | awk 'BEGIN{p=1;} ($1=="C===" && $2=="GENMAKE"){p=0;} {if (p==1) print $0}' \  
         > CPP_OPTIONS.h.tmp  
 fi  
 cat <<EOF >>CPP_OPTIONS.h.tmp  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please edit  
 C  them only if you know what you're doing.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
1146    
1147  C  Packages disabled by genmake:  # Create a list of #define and #undef to enable/disable packages
1148  EOF  PACKAGES_DOT_H=PACKAGES_CONFIG.h
1149  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1150  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1151  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1152  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1153  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1154  all_pack=  all_pack=
1155    DISABLED_PACKAGES=
1156  for n in $names ; do  for n in $names ; do
1157      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1158          has_pack="f"          has_pack="f"
# Line 748  for n in $names ; do Line 1163  for n in $names ; do
1163              fi              fi
1164          done          done
1165          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1166              undef=`echo "ALLOW_$n" | awk '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1167              echo "#undef $undef" >> CPP_OPTIONS.h.tmp              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
   
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
             case $n in  
                 mom_fluxform)  
                     DEFINES="$DEFINES -DDISABLE_MOM_FLUXFORM"  
                     ;;  
                 mom_vecinv)  
                     DEFINES="$DEFINES -DDISABLE_MOM_VECINV"  
                     ;;  
                 generic_advdiff)  
                     DEFINES="$DEFINES -DDISABLE_GENERIC_ADVDIFF"  
                     ;;  
                 debug)  
                     DEFINES="$DEFINES -DDISABLE_DEBUGMODE"  
                     ;;  
             esac  
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
   
1168          fi          fi
1169      fi      fi
1170  done  done
1171  cat <<EOF >>CPP_OPTIONS.h.tmp  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1172  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1173      def=`echo "ALLOW_$i" | awk '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1174      echo "#define $def" >> CPP_OPTIONS.h.tmp      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1175    #eh3 DEFINES="$DEFINES -D$def"
1176    
1177  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1178      case $i in      case $i in
1179          aim_v23)          aim_v23)
1180              echo "#define   ALLOW_AIM" >> CPP_OPTIONS.h.tmp              DEFINES="$DEFINES -DALLOW_AIM"
1181                ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1182                echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"
1183              ;;              ;;
1184      esac      esac
1185  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1186    
1187  done  done
 mv -f CPP_OPTIONS.h.tmp CPP_OPTIONS.h  
1188    
1189  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1190  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1191  STANDARDDIRS=${STANDARDDIRS:-"eesupp model"}  if test "x$STANDARDDIRS" = x ; then
1192        STANDARDDIRS="eesupp model"
1193    fi
1194  for d in $STANDARDDIRS ; do  for d in $STANDARDDIRS ; do
1195      adr="$ROOTDIR/$d/src"      adr="$ROOTDIR/$d/src"
1196      if test ! -d $adr ; then      if test ! -d $adr ; then
# Line 812  for d in $STANDARDDIRS ; do Line 1210  for d in $STANDARDDIRS ; do
1210      fi      fi
1211  done  done
1212    
1213    echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1214    echo "    of \"#define \"-type statements that are no longer allowed:"
1215    CPP_OPTIONS=
1216    CPP_EEOPTIONS=
1217    spaths=". $INCLUDEDIRS"
1218    names=`ls -1 "$ROOTDIR/pkg"`
1219    for i in $spaths ; do
1220        try="$i/CPP_OPTIONS.h"
1221        if test -f $try -a -r $try -a "x$CPP_OPTIONS" == x ; then
1222            echo "    found CPP_OPTIONS=\"$try\""
1223            CPP_OPTIONS="$try"
1224            # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1225            for n in $names ; do
1226                test_for_package_in_cpp_options $CPP_OPTIONS $n
1227            done
1228        fi
1229        try="$i/CPP_EEOPTIONS.h"
1230        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" == x ; then
1231            echo "    found CPP_EEOPTIONS=\"$try\""
1232            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1233    #**** not yet enabled ****
1234    #        test_for_mpi_in_cpp_eeoptions $try
1235    #**** not yet enabled ****
1236            CPP_EEOPTIONS="$try"
1237        fi
1238    done
1239    if test "x$CPP_OPTIONS" = x ; then
1240        echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1241        exit 1
1242    fi
1243    
1244    #  Here, we build the list of files to be "run through" the adjoint
1245    #  compiler.
1246    if test -f ./ad_files ; then
1247        rm -f ./ad_files
1248    fi
1249    echo "  Creating the list of files for the adjoint compiler."
1250    for i in $SOURCEDIRS ; do
1251        list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
1252        for j in $list_files ; do
1253            cat $i/$j >> ad_files
1254        done
1255    done
1256    
1257  echo  echo
1258  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1259  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1260  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1261      if test -d $i ; then      if ! test -d $i ; then
1262          INCLUDES="$INCLUDES -I$i"  #       INCLUDES="$INCLUDES -I$i"
1263      else  #   else
1264          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1265      fi      fi
1266  done  done
# Line 833  echo -n 'SRCFILES = '    > srclist.inc Line 1274  echo -n 'SRCFILES = '    > srclist.inc
1274  echo -n 'CSRCFILES = '   > csrclist.inc  echo -n 'CSRCFILES = '   > csrclist.inc
1275  echo -n 'F90SRCFILES = ' > f90srclist.inc  echo -n 'F90SRCFILES = ' > f90srclist.inc
1276  echo -n 'HEADERFILES = ' > hlist.inc  echo -n 'HEADERFILES = ' > hlist.inc
1277    echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc
1278  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1279  for d in $alldirs ; do  for d in $alldirs ; do
1280      deplist=      deplist=
1281      sfiles=`( cd $d; echo *.[h,c,F] )`      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
1282      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
1283      for sf in $sfiles ; do      for sf in $sfiles ; do
1284          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1285              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1286                  extn=`echo $sf | awk -F '.' '{print $NF}'`                  case $d/$sf in
1287                  touch .links.tmp/$sf                    ./$PACKAGES_DOT_H)
1288                  deplist="$deplist $sf"                          ;;
1289                      ./AD_CONFIG.h)
1290                            ;;
1291                      ./FC_NAMEMANGLE.h)
1292                            ;;
1293                      *)
1294                            touch .links.tmp/$sf
1295                            deplist="$deplist $sf"
1296                            ;;
1297                    esac
1298                    extn=`echo $sf | $AWK -F '.' '{print $NF}'`
1299                  case $extn in                  case $extn in
1300                      F)                      F)
1301                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
# Line 861  for d in $alldirs ; do Line 1313  for d in $alldirs ; do
1313                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1314                          echo -n " $sf" >> hlist.inc                          echo -n " $sf" >> hlist.inc
1315                          ;;                          ;;
1316                        flow)
1317                            echo    " \\"  >> ad_flow_files.inc
1318                            echo -n " $sf" >> ad_flow_files.inc
1319                            ;;
1320                  esac                  esac
1321              fi              fi
1322          fi          fi
# Line 877  echo "" >> srclist.inc Line 1333  echo "" >> srclist.inc
1333  echo "" >> csrclist.inc  echo "" >> csrclist.inc
1334  echo "" >> f90srclist.inc  echo "" >> f90srclist.inc
1335  echo "" >> hlist.inc  echo "" >> hlist.inc
1336    echo "" >> ad_flow_files.inc
1337    
1338  if test -e $MAKEFILE ; then  if test -e $MAKEFILE ; then
1339      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
# Line 890  echo "# by the command:" >> $MAKEFILE Line 1347  echo "# by the command:" >> $MAKEFILE
1347  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $@" >> $MAKEFILE
1348  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1349  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1350    
1351    EXE_AD=$EXECUTABLE"_ad"
1352    EXE_FTL=$EXECUTABLE"_ftl"
1353    EXE_SVD=$EXECUTABLE"_svd"
1354    
1355  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1356    #
1357    # OPTFILE="$OPTFILE"
1358  #  #
1359  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1360  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 918  EXEDIR      = ${EXEDIR} Line 1382  EXEDIR      = ${EXEDIR}
1382  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}
1383  TOOLSDIR    = ${TOOLSDIR}  TOOLSDIR    = ${TOOLSDIR}
1384    
1385    #eh3  new defines for the adjoint work
1386    AUTODIFF    = ${ROOTDIR}/pkg/autodiff
1387    EXE_AD      = ${EXE_AD}
1388    EXE_FTL     = ${EXE_FTL}
1389    EXE_SVD     = ${EXE_SVD}
1390    
1391    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1392    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1393    
1394    # These files are created by Makefile
1395    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1396    
1397  EOF  EOF
1398    
1399  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 963  MAKEFILE=${MAKEFILE} Line 1439  MAKEFILE=${MAKEFILE}
1439    
1440  EOF  EOF
1441    
1442  cat srclist.inc    >> $MAKEFILE  cat srclist.inc       >> $MAKEFILE
1443  cat csrclist.inc   >> $MAKEFILE  cat csrclist.inc      >> $MAKEFILE
1444  cat f90srclist.inc >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1445  cat hlist.inc      >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1446    cat ad_flow_files.inc >> $MAKEFILE
1447    echo               >> $MAKEFILE
1448  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE
1449  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE
1450  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1451    
1452  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1453    rm -f ad_flow_files.inc
1454    
1455  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1456    
# Line 979  cat >>$MAKEFILE <<EOF Line 1458  cat >>$MAKEFILE <<EOF
1458  .SUFFIXES: .o .f .p .F .c .F90 .f90  .SUFFIXES: .o .f .p .F .c .F90 .f90
1459    
1460  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1461  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1462            @echo Creating \$@ ...
1463          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1464  depend:  depend:
1465          @make links          @make links
1466          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1467          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1468    
1469  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1470    
1471  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1472    
# Line 995  output.txt: \$(EXECUTABLE) Line 1475  output.txt: \$(EXECUTABLE)
1475          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1476    
1477  clean:  clean:
1478          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template
1479  Clean:  Clean:
1480          @make clean          @make clean
1481          @make cleanlinks          @make cleanlinks
1482          -rm -f Makefile.bak          -rm -f \$(SPECIAL_FILES)
1483            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1484  CLEAN:  CLEAN:
1485          @make Clean          @make Clean
1486          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1487          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1488          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1489          -rm -f \$(EXECUTABLE)          -rm -f \$(EXECUTABLE) output.txt
1490    
1491    #eh3 Makefile: makefile
1492  makefile:  makefile:
1493          ${0} $@          $THIS_SCRIPT $@
1494  cleanlinks:  cleanlinks:
1495          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1496    
1497    # Special targets ($SPECIAL_FILES) which are create by make
1498    ${PACKAGES_DOT_H}:
1499            @echo Creating \$@ ...
1500            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1501    AD_CONFIG.h:
1502            @echo Creating \$@ ...
1503            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1504    FC_NAMEMANGLE.h:
1505            @echo Creating \$@ ...
1506            echo "$FC_NAMEMANGLE" > \$@
1507    
1508  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .f - .o  )
1509  .F.f:  .F.f:
1510          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
# Line 1030  cleanlinks: Line 1523  cleanlinks:
1523  .p.f:  .p.f:
1524          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1525    
1526    #=========================================
1527    #===  Automatic Differentiation Rules  ===
1528    
1529    TAMC           = ${TAMC}
1530    TAF            = ${TAF}
1531    
1532    TAF_EXTRA      = ${TAF_EXTRA}
1533    TAMC_EXTRA     = ${TAMC_EXTRA}
1534    
1535    EOF
1536    
1537    ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
1538    ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
1539    ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1540    for i in $ad_vars ; do
1541        name=$i
1542        t1="t2=\$"`echo $i`
1543        eval $t1
1544        printf "%-20s = " $name >> $MAKEFILE
1545        echo $t2 >> $MAKEFILE
1546    done
1547    
1548    echo "  Add the source list for AD code generation"
1549    echo >> $MAKEFILE
1550    echo -n "AD_FILES = " >> $MAKEFILE
1551    AD_FILES=`cat ad_files`
1552    for i in $AD_FILES ; do
1553        echo    " \\" >> $MAKEFILE
1554        echo -n " $i" >> $MAKEFILE
1555    done
1556    echo >> $MAKEFILE
1557    rm -f ad_files
1558    
1559    cat >>$MAKEFILE <<EOF
1560    
1561    # ... AD ...
1562    adall: ad_taf
1563    adtaf: ad_taf_output.f
1564    adtamc: ad_tamc_output.f
1565    
1566    ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1567            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1568            cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1569            -rm -f ad_config.template
1570            @make \$(F77FILES)
1571            @make \$(AD_FLOW_FILES)
1572            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1573    
1574    ad_taf_output.f: ad_input_code.f
1575            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1576            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1577    
1578    adtafonly:
1579            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1580            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1581    
1582    ad_taf: ad_taf_output.o \$(OBJFILES)
1583            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1584    
1585    ad_tamc_output.f: ad_input_code.f
1586            \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1587            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
1588    
1589    ad_tamc: ad_tamc_output.o \$(OBJFILES)
1590            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
1591    
1592    
1593    # ... FTL ...
1594    ftlall: ftl_taf
1595    ftltaf: ftl_taf_output.f
1596    ftltamc: ftl_tamc_output.f
1597    
1598    ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1599            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1600            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1601            -rm -f ftl_config.template
1602            @make \$(F77FILES)
1603            @make \$(AD_FLOW_FILES)
1604            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1605    
1606    ftl_taf_output.f: ftl_input_code.f
1607            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1608            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1609    
1610    ftltafonly:
1611            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1612            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1613    
1614    ftl_taf: ftl_taf_output.o \$(OBJFILES)
1615            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1616    
1617    ftl_tamc_output.f: ftl_input_code.f
1618            \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1619            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
1620    
1621    ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1622            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
1623    
1624    
1625    # ... SVD ...
1626    svdtaf: ad_taf_output.f ftl_taf_output.f
1627    svdall: svd_taf
1628    
1629    svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)
1630            \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
1631    
1632    
1633    #=========================================
1634    
1635  EOF  EOF
1636    
1637  if test "x$EXEHOOK" != x ; then  if test "x$EXEHOOK" != x ; then
# Line 1066  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 1668  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
1668    
1669  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
1670    
1671    # Create special header files
1672    $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
1673    if test ! -f $PACKAGES_DOT_H ; then
1674        mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1675    else
1676        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1677        RETVAL=$?
1678        if test "x$RETVAL" = x0 ; then
1679            rm -f $PACKAGES_DOT_H".tmp"
1680        else
1681            mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
1682            mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1683        fi
1684    fi
1685    if test ! -f AD_CONFIG.h ; then
1686        $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
1687    fi
1688    
1689    
1690  #  Write the "state" for future records  #  Write the "state" for future records
1691  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
1692      echo -n "" > gm_state      echo -n "" > genmake_state
1693      for i in $gm_state ; do      for i in $gm_state ; do
1694          t1="t2=\$$i"          t1="t2=\$$i"
1695          eval $t1          eval $t1
1696          echo "$i='$t2'" >> gm_state          echo "$i='$t2'" >> genmake_state
1697      done      done
1698  fi  fi

Legend:
Removed from v.1.9  
changed lines
  Added in v.1.53

  ViewVC Help
Powered by ViewVC 1.1.22